// includes
#include <windows.h>
#include <stdio.h>
#include <vfw.h>

extern HWND window;

// variables
FILE *f;
BYTE tiles[16][16][8][2];
typedef struct { unsigned char b,g,r; } BGR;
BITMAPINFO *bi;
HWND hWnd;



VOID CALLBACK TimerProc1(
  HWND hwnd,         // handle to window
  UINT uMsg,         // WM_TIMER message
  UINT_PTR idEvent,  // timer identifier
  DWORD dwTime       // current system time
)
{
	tiles[8][8][4][0] = rand();
	tiles[8][8][4][1] = rand();
}




// getting videa data from camera
LRESULT CALLBACK OnVideoStream(HWND hWnd, LPVIDEOHDR lpVHdr)
{
	HANDLE h = ICImageDecompress(NULL, 0, bi, lpVHdr->lpData, NULL);
	LPBITMAPINFOHEADER bmi = (LPBITMAPINFOHEADER)GlobalLock(h);
	BGR *cap = (BGR*)((char*)bmi + bmi->biSize);

	int error=0;

	// make tiles
	for (int ty=0; ty<16; ty++)
	{
		for (int y=0; y<8; y++)
		{
			BGR *c = &cap[bmi->biWidth*(127 - (ty*8+y))];
			for (int tx=0; tx<16; tx++)
			{
				unsigned char l=0,h=0;
				for (int x=0; x<8; x++)
				{
					//56*255 + 182*255 + 18*255
					int q = (56*c->r + 181*c->g + 18*c->b) / 256;//-error;
					if (q < 0) q=0;
					if (q > 255) q=255;
					int gb = q / 64;
					int q2 = gb * 64;
					error = (q2 - q) * 2 / 3;
					l = l<<1 | (gb & 1 ? 0 : 1);
					h = h<<1 | (gb & 2 ? 0 : 1);
					c++;
				}
				tiles[ty][tx][y][0] = l;
				tiles[ty][tx][y][1] = h;
			}
		}
	}

	GlobalFree(h);
	return (LRESULT)TRUE;
}

void DF_init()
{
	/*/ load test file
	f = fopen("test.bin", "rb");
	fread(tiles, sizeof(tiles), 1, f);
	fclose(f);*/

	// open test log
	f = fopen("df.txt", "wt");

	// init capture window
	hWnd = capCreateCaptureWindow("Capture window", WS_CHILD|WS_VISIBLE/*|WS_OVERLAPPEDWINDOW*/, 0,0,1,1, window, 0);
	//hWnd = capCreateCaptureWindow("", WS_CHILD, 0,0,320,240, window, 0);
	capDriverConnect(hWnd, 0);
	int size = capGetVideoFormatSize(hWnd);
	bi = (LPBITMAPINFO)new char[size];
	capGetVideoFormat(hWnd, bi, size);

	capSetCallbackOnFrame(hWnd, OnVideoStream);
	//capSetCallbackOnVideoStream(hWnd, OnVideoStream);
	//capCaptureSequenceNoFile(hWnd);
	capPreviewRate(hWnd, 33);     // rate, in milliseconds
	capPreview(hWnd, TRUE);       // starts preview 


	//SetTimer(NULL, 0, 100, (TIMERPROC)TimerProc1);
}

void DF_done()
{
	capDriverDisconnect(hWnd);
	delete bi;
	if (f) fclose(f);
}


// logger
void Log(char c, unsigned int addr, unsigned char data)
{
	if (f) fprintf(f, "%c %04X %02X\n", c, addr, data);
}
